'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = require('events');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EventEmitter = function (_EventEmitterBase) {
  _inherits(EventEmitter, _EventEmitterBase);

  function EventEmitter() {
    _classCallCheck(this, EventEmitter);

    return _possibleConstructorReturn(this, (EventEmitter.__proto__ || Object.getPrototypeOf(EventEmitter)).apply(this, arguments));
  }

  _createClass(EventEmitter, [{
    key: 'off',


    /**
     * @param {String} event - optional event name
     * @param {Function} listener - optional listener
     * @return {EventEmitter}
     */
    value: function off() {
      var _this2 = this;

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var arity = args.length;
      var event = args[0];
      var listener = args[1];

      var remove = function remove() {
        return _this2.removeListener.apply(_this2, arguments);
      };

      // remove a single listener at arity 2
      if (arity >= 2) {
        remove(event, listener);
      } else if (arity === 1) {
        this.listeners(event).forEach(function (listener) {
          return remove(event, listener);
        });
      } else {
        this.removeAllListeners();
      }

      return this;
    }
  }]);

  return EventEmitter;
}(_events.EventEmitter);

exports.default = { EventEmitter: EventEmitter };
module.exports = exports['default'];