'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * Return a pseudo-random UUID
 * @param void
 * @return {String}
 */
var v4 = function v4() {
  var random = Math.random;

  var uuid = '';

  for (var i = 0; i < 32; i++) {
    var r = random() * 16 | 0;

    if (i === 8 || i === 12 || i === 16 || i === 20) {
      uuid += '-';
    }

    uuid += (i == 12 ? 4 : i == 16 ? r & 3 | 8 : r).toString(16);
  }

  return uuid;
};

exports.default = { v4: v4 };
module.exports = exports['default'];